<?php
/*
Plugin Name: Flattr Widget
Version: 0.1
Plugin URI: http://wordpress.org/extend/plugins/flattr-widget/
Description: Provides easy shortcode access to inserting custom Flattr widgets
Author: Fabrizio Lungo
Author URI: http://fabrizio.me.uk/

Copyright 2010 Fabrizio Lungo (email: flattr-widget@fabrizio.me.uk)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

function determine_flattr_cat($input) {
	$input = strtolower($input);
	switch($input) {
		case 'audio':
			return "audio";
		case 'images':
		case 'image':
			return "images";
		case 'video':
		case 'videos':
			return "video";
		case 'software':
			return "software";
		case 'rest':
		case 'other':
			return "rest";
		case 'text':
		default:
			return "text";
	}
}

function determine_flattr_lng($input) {
	$input = strtolower($input);
	if ($input = '')
		return "en_gb";
	else
		return $input;
}

function determine_flattr_hide($input) {
	$input = strtolower($input);
	switch($input) {
		case 't':
		case 'true':
			return "true";
		case 'f':
		case 'false':
		default:
			return "flase";
	}
}

function flattr_widget($atts, $content) {
	if ($content != '' || get_option('flattr_uid') != '') {
		if ($atts['btn'] != '')
			$flattr_btn		=	$atts['btn'];
		if ($content != '')
			$flattr_uid		= 	$content;
		elseif (get_option('flattr_uid') != '')
			$flattr_uid		= 	get_option('flattr_uid');
		if ($atts['tle'] != '')
			$flattr_tle		=	$atts['tle'];
		else
			$flattr_tle		=	get_the_title();
		if ($atts['dsc'] != '')
			$flattr_dsc		=	$atts['dsc'];
		else
			$flattr_dsc		=	$this->getExcerpt();
		$flattr_cat			=	determine_flattr_cat($atts['cat']);
		$flattr_lng			=	determine_flattr_lng($atts['lng']);
		if ($atts['tag'] != '')
			$flattr_tag		=	$atts['tag'];
		if ($atts['url'] != '')
			$flattr_url		=	$atts['url'];
		else
			$flattr_url		=	get_permalink();
		$flattr_hide		=	determine_flattr_hide($atts['hide']);
	
		$output = 		 "<script type=\"text/javascript\">\n";
		if ($flattr_btn != '')
			$output .=	 "var flattr_btn = '" . $flattr_btn . "';\n";
		$output .=		 "var flattr_uid = '" . $flattr_uid . "';\n"
						."var flattr_tle = '" . $flattr_tle . "';\n"
						."var flattr_dsc = '" . $flattr_dsc . "';\n"
						."var flattr_cat = '" . $flattr_cat . "';\n"
						."var flattr_lng = '" . $flattr_lng . "';\n";
		if ($flattr_tag != '')
			$output .=	 "var flattr_tag = '" . $flattr_tag . "';\n";
		if ($flattr_url != '')
			$output .=	 "var flattr_url = '" . $flattr_url . "';\n";
		if ($flattr_hide = "true")
			$output .=	 "var flattr_hide = '" . $flattr_hide . "';\n";
		$output 	.=	 "</script>\n"
						."<script src=\"http://api.flattr.com/button/load.js\" type=\"text/javascript\"></script>\n";
		if (get_option('flattr_compact', 'null') != 'null' && $flattr_btn != '') {
			if ((!get_option('flattr_compact') && $flattr_btn = 'compact')) {
				$output .=	 "<script type=\"text/javascript\">"
							."var flattr_btn = 'large';\n"
							."</script>\n";
			}
		}

		return $output;
	}
	else
		return "<b>Flattr Widget Failed: A required variable was missing</b>";
}

add_shortcode('flattr', 'flattr_widget');
?>